%%
%% appexecfactory.tex
%% $Id: appexecfactory.tex,v 1.8 2003-03-07 10:01:20 baurma Exp $
%%

\section{JNukeExecFactory}

\label{app:execfactory}

All implemented functions performing actual bytecode instrumentation 
have been combined into a collection object called \texttt{JNukeExecFactory}.
Figure~\ref{fig:execfactoryfunclist} shows a list of all available
functions.

To obtain a particular implementation of an instrumentation function, 
the function factory can be queried using the \texttt{JNukeExecFactory\_get}
method. Individual functions are selected by using an integer constant
with a descriptive name.

\texttt{JNukeExecFactory} is a static object and therefore does not require
a constructor.

\begin{figure}[ht!]
\begin{center}
\begin{tabular}{|l|}
\hline
Name                                     \\
\hline
exec\_doNothing                          \\
exec\_replay\_init                       \\
exec\_replay\_sync                       \\
exec\_replay\_registerThreadForNew       \\
exec\_replay\_blockThis                  \\
exec\_replay\_objectWaitWorkaroundPre    \\
exec\_replay\_objectWaitWorkaroundPost   \\
exec\_replay\_objectNotifyWorkaroundPre  \\
exec\_replay\_objectNotifyWorkaroundPost \\
exec\_replay\_threadInterruptWorkaround  \\
exec\_replay\_terminate                  \\
exec\_removeInstruction \\
\hline
\end{tabular}
\end{center}
\caption{Predefined factory instrumentation methods}
\label{fig:execfactoryfunclist}
\end{figure}


%% ------------------------------------------------------------------

\subsection{JNukeExecFactory\_get}

\code{
ir\_execfunc \\
JNukeExecFactory\_get ( \\
\tab    execFactoryMethod idx \\
)
}


\subsubsection{Description}

Return a pointer to a particular implementation from the collection of 
implemented instrumentation function.

\subsubsection{Parameters}

\begin{description}
\ttitem{idx}
	Symbolic constant to access the instrumentation function.
\end{description}

\subsubsection{Return value}

A pointer to the factory method or \texttt{NULL} if the 
index into the function collection was invalid. The returned
pointer will reference a function that has the following
signature:

\code{
void \\
ir\_execfunc ( \\
\tab	JNukeObj * instrument \\
)
}
